#include "stack.h"

int main (int argc, char **argv) {

  char c;

  char L_PAREN    = '(';
  char R_PAREN    = ')';
  char L_BRACE    = '{';
  char R_BRACE    = '}';
  char L_BRACKET  = '[';
  char R_BRACKET  = ']';

  int retval;
  STACK *stack = NULL;
  stack = initStack();

  printf("Enter a string: ");

  while ((c = getchar()) != '\n') {
    if (c == L_PAREN)
      push(stack, L_PAREN);
    else if (c == L_BRACE)
      push(stack, L_BRACE);
    else if (c == L_BRACKET) 
      push(stack, L_BRACKET);
    else if (c == R_PAREN) {
      if (stack->size==0) {
	//return false;
	printf("Parentheses not balanced RP\n");
	return 0;
      }
      pop(stack, &retval);
      if (retval != L_PAREN) {
	//return false;
	printf("Parentheses not balanced LP\n");
	return 0;
      }
    }
    else if (c == R_BRACE) {
      if (stack->size==0) {
	//return false;
	printf("Parentheses not balanced RB\n");
	return 0;
      }
      pop(stack, &retval);
      if (retval != L_BRACE) {
	//return false;
	printf("Parentheses not balanced LB\n");
	return 0;
      }
    }
    else if (c == R_BRACKET) {
      if (stack->size==0){
	//return false;
	printf("Parentheses not balanced RBR\n");
	return 0;
      } 
      pop(stack, &retval);
      if (retval != L_BRACKET) {
	//return false;
	printf("Parentheses not balanced LBR\n");
	return 0;
      }
    }   
  }
  if (stack->size==0)
    printf("Parentheses are balanced\n");
  else
    printf("Parentheses not balanced\n");

  return 0;

}